// Copyright © 2023 ab180. All rights reserved.

#include "AirbridgeUnreal.h"
#include "AirbridgeUnrealModule.h"

#pragma region Core

void FAirbridge::EnableSDK()
{
	FAirbridgeUnrealModule::Get()->GetAirbridge()->EnableSDK();
}

void FAirbridge::DisableSDK()
{
	FAirbridgeUnrealModule::Get()->GetAirbridge()->DisableSDK();
}

bool FAirbridge::IsSDKEnabled()
{
	return FAirbridgeUnrealModule::Get()->GetAirbridge()->IsSDKEnabled();
}

#pragma endregion

#pragma region Privacy

void FAirbridge::StartTracking()
{
	FAirbridgeUnrealModule::Get()->GetAirbridge()->StartTracking();
}

void FAirbridge::StopTracking()
{
	FAirbridgeUnrealModule::Get()->GetAirbridge()->StopTracking();
}

bool FAirbridge::IsTrackingEnabled()
{
	return FAirbridgeUnrealModule::Get()->GetAirbridge()->IsTrackingEnabled();
}
    
#pragma endregion

#pragma region Deeplink

void FAirbridge::SetOnDeeplinkReceived(const AirbridgeStringParamFunction& OnDeeplinkReceived)
{
	FAirbridgeUnrealModule::Get()->GetAirbridge()->SetOnDeeplinkReceived(OnDeeplinkReceived);
}

#pragma endregion

#pragma region Data Collection

void FAirbridge::SetUserID(const FString& Id)
{
	FAirbridgeUnrealModule::Get()->GetAirbridge()->SetUserID(Id);
}

void FAirbridge::ClearUserID()
{
	FAirbridgeUnrealModule::Get()->GetAirbridge()->ClearUserID();
}

void FAirbridge::SetUserEmail(const FString& Email)
{
	FAirbridgeUnrealModule::Get()->GetAirbridge()->SetUserEmail(Email);
}

void FAirbridge::ClearUserEmail()
{
	FAirbridgeUnrealModule::Get()->GetAirbridge()->ClearUserEmail();
}

void FAirbridge::SetUserPhone(const FString& Phone)
{
	FAirbridgeUnrealModule::Get()->GetAirbridge()->SetUserPhone(Phone);
}

void FAirbridge::ClearUserPhone()
{
	FAirbridgeUnrealModule::Get()->GetAirbridge()->ClearUserPhone();
}

void FAirbridge::SetUserAttribute(const FString& Key, const int32 Value)
{
	FAirbridgeUnrealModule::Get()->GetAirbridge()->SetUserAttribute(Key, Value);
}

void FAirbridge::SetUserAttribute(const FString& Key, const int64 Value)
{
	FAirbridgeUnrealModule::Get()->GetAirbridge()->SetUserAttribute(Key, Value);
}

void FAirbridge::SetUserAttribute(const FString& Key, const float Value)
{
	FAirbridgeUnrealModule::Get()->GetAirbridge()->SetUserAttribute(Key, Value);
}

void FAirbridge::SetUserAttribute(const FString& Key, const double Value)
{
	FAirbridgeUnrealModule::Get()->GetAirbridge()->SetUserAttribute(Key, Value);
}

void FAirbridge::SetUserAttribute(const FString& Key, const bool Value)
{
	FAirbridgeUnrealModule::Get()->GetAirbridge()->SetUserAttribute(Key, Value);
}

void FAirbridge::SetUserAttribute(const FString& Key, const FString& Value)
{
	FAirbridgeUnrealModule::Get()->GetAirbridge()->SetUserAttribute(Key, Value);
}

void FAirbridge::RemoveUserAttribute(const FString& Key)
{
	FAirbridgeUnrealModule::Get()->GetAirbridge()->RemoveUserAttribute(Key);
}

void FAirbridge::ClearUserAttributes()
{
	FAirbridgeUnrealModule::Get()->GetAirbridge()->ClearUserAttributes();
}

void FAirbridge::SetUserAlias(const FString& Key, const FString& Value)
{
	FAirbridgeUnrealModule::Get()->GetAirbridge()->SetUserAlias(Key, Value);
}

void FAirbridge::RemoveUserAlias(const FString& Key)
{
	FAirbridgeUnrealModule::Get()->GetAirbridge()->RemoveUserAlias(Key);
}

void FAirbridge::ClearUserAlias()
{
	FAirbridgeUnrealModule::Get()->GetAirbridge()->ClearUserAlias();
}

void FAirbridge::ClearUser()
{
	FAirbridgeUnrealModule::Get()->GetAirbridge()->ClearUser();
}
	
void FAirbridge::SetDeviceAlias(const FString& Key, const FString& Value)
{
	FAirbridgeUnrealModule::Get()->GetAirbridge()->SetDeviceAlias(Key, Value);
}

void FAirbridge::RemoveDeviceAlias(const FString& Key)
{
	FAirbridgeUnrealModule::Get()->GetAirbridge()->RemoveDeviceAlias(Key);
}

void FAirbridge::ClearDeviceAlias()
{
	FAirbridgeUnrealModule::Get()->GetAirbridge()->ClearDeviceAlias();
}

void FAirbridge::RegisterPushToken(const FString& Token)
{
	FAirbridgeUnrealModule::Get()->GetAirbridge()->RegisterPushToken(Token);
}

#pragma endregion 

#pragma region Event

void FAirbridge::TrackEvent(const FString& Category, const UAirbridgeMap* SemanticAttributes, const UAirbridgeMap* CustomAttributes)
{
	FAirbridgeUnrealModule::Get()->GetAirbridge()->TrackEvent(Category, SemanticAttributes, CustomAttributes);
}

#pragma endregion

#pragma region Placement

void FAirbridge::Click(const FString& TrackingLink, const AirbridgeVoidParamFunction& OnSuccess, const AirbridgeStringParamFunction& OnFailure)
{
	FAirbridgeUnrealModule::Get()->GetAirbridge()->Click(TrackingLink, OnSuccess, OnFailure);
}

void FAirbridge::Impression(const FString& TrackingLink, const AirbridgeVoidParamFunction& OnSuccess, const AirbridgeStringParamFunction& OnFailure)
{
	FAirbridgeUnrealModule::Get()->GetAirbridge()->Impression(TrackingLink, OnSuccess, OnFailure);
}

#pragma endregion

#pragma region Publication

void FAirbridge::FetchDeviceUUID(const AirbridgeStringParamFunction& OnSuccess, const AirbridgeStringParamFunction& OnFailure)
{
	FAirbridgeUnrealModule::Get()->GetAirbridge()->FetchDeviceUUID(OnSuccess, OnFailure);
}

void FAirbridge::FetchAirbridgeGeneratedUUID(const AirbridgeStringParamFunction& OnSuccess, const AirbridgeStringParamFunction& OnFailure)
{
	FAirbridgeUnrealModule::Get()->GetAirbridge()->FetchAirbridgeGeneratedUUID(OnSuccess, OnFailure);
}

void FAirbridge::SetOnAttributionReceived(const AirbridgeMapParamFunction& OnAttributionReceived)
{
	FAirbridgeUnrealModule::Get()->GetAirbridge()->SetOnAttributionReceived(OnAttributionReceived);
}

void FAirbridge::CreateTrackingLink(
	const FString& Channel,
	const UAirbridgeMap* Option,
	const AirbridgeTrackingLinkParamFunction& OnSuccess,
	const AirbridgeStringParamFunction& OnFailure
)
{
	FAirbridgeUnrealModule::Get()->GetAirbridge()->CreateTrackingLink(Channel, Option, OnSuccess, OnFailure);
}

#pragma endregion

#pragma region Hybrid

FString FAirbridge::CreateWebInterfaceScript(const FString& WebToken, const FString& PostMessageScript)
{
	return FAirbridgeUnrealModule::Get()->GetAirbridge()->CreateWebInterfaceScript(WebToken, PostMessageScript);
}

void FAirbridge::HandleWebInterfaceCommand(const FString& Command)
{
	FAirbridgeUnrealModule::Get()->GetAirbridge()->HandleWebInterfaceCommand(Command);
}

#pragma endregion

#pragma region IAP

void FAirbridge::StartInAppPurchaseTracking()
{
	FAirbridgeUnrealModule::Get()->GetAirbridge()->StartInAppPurchaseTracking();
}

void FAirbridge::StopInAppPurchaseTracking()
{
	FAirbridgeUnrealModule::Get()->GetAirbridge()->StopInAppPurchaseTracking();
}

bool FAirbridge::IsInAppPurchaseTrackingEnabled()
{
	return FAirbridgeUnrealModule::Get()->GetAirbridge()->IsInAppPurchaseTrackingEnabled();
}

void FAirbridge::SetOnInAppPurchaseReceived(const AirbridgeInAppPurchaseParamFunction& OnReceived)
{
	FAirbridgeUnrealModule::Get()->GetAirbridge()->SetOnInAppPurchaseReceived(OnReceived);
}

#pragma endregion

bool FAirbridge::IsUninstallTrackingNotification(const TMap<FString, FString>& Data)
{
	return Data.Contains("airbridge-uninstall-tracking");
}
