// Copyright © 2023 ab180. All rights reserved.

#pragma once

#include "Modules/ModuleManager.h"
#include "EngineMinimal.h"
#include "Interfaces/AirbridgeCore.h"

typedef TSharedPtr<IAirbridgeCore, ESPMode::ThreadSafe> FAirbridgeCorePointer;

/** @cond HIDDEN_SYMBOLS */
class FAirbridgeUnrealModule : public IModuleInterface
{
public:
	static FAirbridgeUnrealModule* Get()
	{
		return FModuleManager::LoadModulePtr<FAirbridgeUnrealModule>("AirbridgeUnreal");
	}

	virtual void StartupModule() override;
	virtual void ShutdownModule() override;

	FAirbridgeCorePointer GetAirbridge() const
	{
		return AirbridgeCorePointer;
	}

protected:
	FAirbridgeCorePointer AirbridgeCorePointer;
};
/** @endcond */